<!-- 溯源结果确认列表 -->
<script name="EquipmentResultConfirmList" lang="ts" setup>
import type { Ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { DateModelType } from 'element-plus'
import type { IList, IListQuery } from './resultConfirm-interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getDictByCode } from '@/api/system/dict'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import ApprovalDialog from '@/components/Approval/ApprovalDialog.vue'
import type { deptType } from '@/global'
import { exportFile } from '@/utils/exportUtils'
import ButtonBox from '@/components/buttonBox/buttonBox.vue'
import { SCHEDULE } from '@/utils/scheduleDict'
import {
  approvalDelete,
  cancelApproval,
  draftDelete,
  exportResultConfirmList,
  getResultConfirmList,
  refuseApproval,
} from '@/api/equipment/source/resultConfirm'
const approvalDialog = ref() // 审批对话ref
const $route = useRoute()
const $router = useRouter()
const { proxy } = getCurrentInstance() as any
const operateWidth = ref('150') // 操作栏的宽度
const buttonBoxActive = 'equipmentSourceResultConfirmApproval' // 存储在sessionstorage里面的字段名，用于记录右上角buttonbox点击状态
const loadingTable = ref(false)
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const active = ref('') // 右上方按钮
// 查询条件
const listQuery: Ref<IListQuery> = ref({
  approvalStatus: active.value, // 审批状态
  createTimeEnd: '', // 申请时间结束
  createTimeStart: '', // 申请时间开始
  createUserName: '', // 申请人
  formId: SCHEDULE.TRACE_RESULT_VERIFICATION_APPROVAL, // formid
  confirmName: '', // 登记表名字
  confirmNo: '', // 登记表编号
  equipmentNo: '', // 统一编号
  equipmentName: '', // 设备名称
  limit: 20,
  offset: 1,
})

// 表头
const columns = ref<TableColumn[]>([
  { text: '登记表编号', value: 'confirmNo', align: 'center', width: '160' },
  { text: '登记表名称', value: 'confirmName', align: 'center' },
  { text: '统一编号', value: 'equipmentNo', align: 'center', width: '160' },
  { text: '设备名称', value: 'equipmentName', align: 'center' },
  { text: '型号规格', value: 'model', align: 'center' },
  { text: '创建人', value: 'createUserName', align: 'center' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '180' },
])
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const list = ref<IList[]>([]) // 列表
const total = ref(0) // 数据总条数
// 选中的内容
const checkoutList = ref<string[]>([])
// -----------------------------------------字典--------------------------------------------------------------
// 查询字典
const getDict = async () => {
  loadingTable.value = true
  // 审批状态
  const res = await getDictByCode('approvalStatus')
  // 制作右上角的菜单
  const tempMenu = ['全部', '已审批', '待审批', '审批', '草稿箱', '审批中', '已通过', '未通过', '已取消']
  tempMenu.forEach((item) => {
    const tempFindData = res.data.find((e: { name: string; value: string }) => e.name === item)
    if (tempFindData) {
      menu.value.push({
        name: tempFindData.name,
        id: `${tempFindData.value}`,
      })
    }
  })
}
// ----------------------------------------列表数据----------------------------------------------------
// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getResultConfirmList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 重置
const clearList = () => {
  listQuery.value = {
    approvalStatus: active.value, // 审批状态
    createTimeEnd: '', // 申请时间结束
    createTimeStart: '', // 申请时间开始
    createUserName: '', // 申请人
    formId: SCHEDULE.TRACE_RESULT_VERIFICATION_APPROVAL, // formid
    confirmName: '', // 登记表名字
    confirmNo: '', // 登记表编号
    equipmentNo: '', // 统一编号
    equipmentName: '', // 设备名称
    limit: 20,
    offset: 1,
  }
  dateRange.value = ['', '']
  fetchData()
}
// 搜索
const searchList = () => {
  fetchData(true)
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// ----------------------------------------按钮-------------------------------------------------
// 新建
const add = () => {
  $router.push({
    path: 'resultConfirm/add',
  })
}
// 导出
const exportAll = () => {
  const loading = ElLoading.service({
    lock: true,
    text: '下载中请稍后',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (list.value.length > 0) {
    const params = {
      approvalStatus: listQuery.value.approvalStatus, // 审批状态
      createTimeEnd: listQuery.value.createTimeEnd, // 申请时间结束
      createTimeStart: listQuery.value.createTimeStart, // 申请时间开始
      createUserName: listQuery.value.createUserName, // 申请人
      formId: listQuery.value.formId, // formid
      confirmName: listQuery.value.confirmName, // 登记表名字
      confirmNo: listQuery.value.confirmNo, // 登记表编号
      equipmentNo: listQuery.value.equipmentNo, // 统一编号
      equipmentName: listQuery.value.equipmentName, // 设备名称
      offset: 1,
      limit: 20,
      ids: checkoutList.value,
    }
    exportResultConfirmList(params).then((res) => {
      const blob = new Blob([res.data])
      exportFile(blob, '溯源结果确认.xlsx')
      loading.close()
    })
  }
  else {
    loading.close()
    ElMessage.warning('无数据可导出数据')
  }
}
// ----------------------------------------------操作---------------------------------------------------
const handleEdit = (row: IList, type: string) => {
  if (type === 'edit' || type === 'detail') { // 编辑、详情
    if (active.value === '0' && type === 'detail') {
      $router.push({
        path: `resultConfirmDoc/${type}/${row.id}`,
        query: {
          approvalStatusName: '全部', // 审批状态名称
          processId: row.processId, // 流程实例id
          taskId: row.taskId, // 任务id
        },
      })
    }
    else {
      $router.push({
        path: `resultConfirm/${type}/${row.id}`,
        query: {
          approvalStatusName: active.value === '0' ? '全部' : active.value === '7' ? '已审批' : row.approvalStatusName, // 审批状态名称
          processId: row.processId, // 流程实例id
          taskId: row.taskId, // 任务id
        },
      })
    }
  }
  else if (type === '同意') {
    approvalDialog.value.initDialog('agree', row.taskId)
  }
  else if (type === '拒绝') {
    approvalDialog.value.initDialog('refuse', row.taskId, row.id)
  }
  else if (type === '取消') {
    const params = {
      processInstanceId: row.processId!,
      comments: '',
      id: row.id,
    }
    ElMessageBox.confirm(
      '确认取消该审批吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        cancelApproval(params).then((res) => {
          ElMessage({
            type: 'success',
            message: '已取消',
          })
          fetchData(true)
        })
      })
  }
  else {
    ElMessageBox.confirm(
      `确认${type}吗？`,
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    ).then(() => {
      // 草稿箱删除
      if (type === '删除' && row.approvalStatusName === '草稿箱') {
        draftDelete({ id: row.id }).then(() => {
          ElMessage.success(`已${type}`)
          fetchData()
        })
      }
      // 审批删除--已取消、全部
      else if (type === '删除' && (row.approvalStatusName === '已取消' || active.value === '0')) {
        approvalDelete({ id: row.id, taskId: row.taskId! }).then(() => {
          ElMessage.success(`已${type}`)
          fetchData()
        })
      }
    })
  }
}
// 拒绝
const refuse = (comments: string, taskId: string, id: string) => {
  const params = {
    id,
    taskId, // 任务id
    comments, // 拒绝原因
  }
  refuseApproval(params).then((res) => {
    ElMessage({
      type: 'success',
      message: '已拒绝',
    })
    fetchData(true)
  })
}
// -----------------------------------------审批------------------------------------------------
// 审批结束回调
const approvalSuccess = () => {
  fetchData(true)
}

// 切换tab状态
const changeCurrentButton = (val: string) => {
  active.value = val
  window.sessionStorage.setItem(buttonBoxActive, val)
  clearList()
}

// ------------------------------------------钩子------------------------------------------------
watch(dateRange, (val) => {
  if (val) {
    listQuery.value.createTimeStart = `${val[0]}`
    listQuery.value.createTimeEnd = `${val[1]}`
  }
  else {
    listQuery.value.createTimeStart = ''
    listQuery.value.createTimeEnd = ''
  }
})
onMounted(async () => {
  await getDict()
  if (window.sessionStorage.getItem(buttonBoxActive)) {
    active.value = window.sessionStorage.getItem(buttonBoxActive)!
  }
  else {
    active.value = menu.value.find(item => item.name === '全部')!.id as string // 全部
  }
})
</script>

<template>
  <div>
    <!-- 布局 -->
    <app-container>
      <search-area :need-clear="true" @search="searchList" @clear="clearList">
        <search-item>
          <el-input v-model.trim="listQuery.confirmNo" placeholder="登记表编号" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.confirmName" placeholder="登记表名称" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.equipmentNo" placeholder="统一编号" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.equipmentName" placeholder="设备名称" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.createUserName" placeholder="创建人" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-date-picker
            v-model="dateRange"
            class="short-input"
            type="datetimerange"
            range-separator="至"
            format="YYYY-MM-DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
            start-placeholder="创建时间(开始)"
            end-placeholder="创建时间(结束)"
          />
        </search-item>
      </search-area>
      <table-container>
        <!-- 全部的时候展示按钮 -->
        <template v-if="active === '0'" #btns-right>
          <icon-button icon="icon-add" title="新建" type="primary" @click="add" />
          <icon-button icon="icon-export" title="导出" type="primary" @click="exportAll" />
        </template>
        <normal-table
          :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
          is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column
              label="操作"
              align="center"
              fixed="right"
              :width="operateWidth"
            >
              <template #default="{ row }">
                <el-button
                  v-if="active !== '1' && active !== '6' && active !== '5'"
                  size="small"
                  type="primary"
                  link
                  @click="handleEdit(row, 'detail')"
                >
                  查看
                </el-button>
                <el-button
                  v-if=" active === '1' || active === '6' || active === '5'"
                  size="small"
                  type="primary"
                  link
                  @click="handleEdit(row, 'edit')"
                >
                  查看
                </el-button>
                <el-button
                  v-if="row.approvalStatusName === '待审批'"
                  size="small"
                  link
                  type="primary"
                  @click="handleEdit(row, '同意')"
                >
                  同意
                </el-button>
                <el-button
                  v-if="row.approvalStatusName === '待审批'"
                  size="small"
                  link
                  type="danger"
                  @click="handleEdit(row, '拒绝')"
                >
                  拒绝
                </el-button>
                <el-button
                  v-if="active === '0'"
                  size="small"
                  link
                  type="primary"
                  @click="handleEdit(row, 'edit')"
                >
                  编辑
                </el-button>

                <!-- 是发起者且审批中可以取消 -->
                <el-button
                  v-if="row.approvalStatusName === '审批中' && active !== '7' && active !== '0'"
                  size="small"
                  link
                  type="info"
                  @click="handleEdit(row, '取消')"
                >
                  取消
                </el-button>
                <el-button
                  v-if="active !== '7' && (active === '0' || row.approvalStatusName === '草稿箱' || row.approvalStatusName === '已取消')"
                  size="small"
                  link
                  type="danger"
                  @click="handleEdit(row, '删除')"
                >
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
      <!-- 审批弹窗 -->
      <approval-dialog ref="approvalDialog" @on-success="approvalSuccess" @refuse="refuse" />
      <!-- 右上角按钮集合 -->
      <button-box :active="active" :menu="menu" @change-current-button="changeCurrentButton" />
    </app-container>
  </div>
</template>

